#-------------------------------------------------
#
# Project created by QtCreator 2013-10-09T21:46:34
#
#-------------------------------------------------

QT       += core gui opengl

DEFINES     += QT_NO_DEBUG_OUTPUT QT_NO_WARNING_OUTPUT

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = DIP
TEMPLATE = app

MOC_DIR += $$PWD/build
UI_DIR += $$PWD/build
OBJECTS_DIR += $$PWD/build

QMAKE_CXXFLAGS += -std=gnu++11

INCLUDEPATH += src\
    src/scenes \
    src/gui \
    src/shaders \
    src/chess \
    src/demo

SOURCES += src/main.cpp\
	src/gui/mainwindow.cpp \
    src/glview.cpp \
    src/shaders/baseshader.cpp \
    src/variables.cpp \
    src/scenes/scenemanager.cpp \
    src/scenes/scene.cpp \
    src/scenes/modelloader.cpp \
    src/scenes/model.cpp \
    src/scenes/scenes.cpp \
    src/shaders/lightshader.cpp \
    src/gui/scenechooser.cpp \
    src/shaders/shadowvolumeshader.cpp \
    src/gui/shaderchooser.cpp \
    src/shaders/hybridshader.cpp \
    src/shaders/shadowmapshader.cpp \
    src/shaders/hybridshaderv2.cpp \
    src/shaders/hybridshaderv2ati.cpp \
    src/chess/raycollision.cpp \
    src/scenes/node.cpp \
    src/scenes/geometry.cpp \
    src/scenes/material.cpp \
    src/scenes/light.cpp \
    src/shaders/shadowcubemapshader.cpp \
    src/shaders/chessshader.cpp \
    src/shaders/mousepickshader.cpp \
    src/chess/chesslogic.cpp \
    src/shaders/gbuffer.cpp \
    src/shaders/ssaoshader.cpp \
    src/shaders/shadowcubemapshader2.cpp \
    src/shaders/shadowmulticubemapshader.cpp \
    src/shaders/materialshader.cpp \
    src/demo/democontroller.cpp \
    src/shaders/loadingshader.cpp

HEADERS  += src/gui/mainwindow.h \
    src/glview.h \
    src/shaders/baseshader.h \
    src/variables.h \
    src/scenes/scenemanager.h \
    src/scenes/scene.h \
    src/scenes/modelloader.h \
    src/scenes/model.h \
    src/scenes/scenes.h \
    src/shaders/lightshader.h \
    src/gui/scenechooser.h \
    src/shaders/shadowvolumeshader.h \
    src/gui/shaderchooser.h \
    src/shaders/hybridshader.h \
    src/shaders/shadowmapshader.h \
    src/shaders/hybridshaderv2.h \
    src/shaders/hybridshaderv2ati.h \
    src/chess/raycollision.h \
    src/scenes/node.h \
    src/scenes/geometry.h \
    src/scenes/material.h \
    src/scenes/light.h \
    src/shaders/shadowcubemapshader.h \
    src/scenes/drawlist.h \
    src/shaders/chessshader.h \
    src/shaders/mousepickshader.h \
    src/chess/chesslogic.h \
    src/shaders/gbuffer.h \
    src/shaders/ssaoshader.h \
    src/shaders/shadowcubemapshader2.h \
    src/shaders/shadowmulticubemapshader.h \
    src/shaders/allshaders.h \
    src/shaders/materialshader.h \
    src/demo/democontroller.h \
    src/shaders/loadingshader.h

FORMS    += src/gui/mainwindow.ui \
    src/gui/scenechooser.ui \
    src/gui/shaderchooser.ui

OTHER_FILES += \
    shaders/empty.frag \
    shaders/bufferview.vert \
    shaders/shadowvolume.vert \
    shaders/shadowvolume.geo \
    shaders/normalview.frag \
    shaders/empty.vert \
    shaders/hybrid/pass1.vert \
    shaders/hybrid/pass1.frag \
    shaders/hybrid/pass1buffer.frag \
    shaders/hybrid/pass1buffer.vert \
    shaders/hybrid/pass2.vert \
    shaders/hybrid/pass2.frag \
    shaders/hybrid/pass2buffer.frag \
    shaders/hybrid/pass2buffer.vert \
    shaders/hybrid/pass2depth.frag \
    shaders/hybrid/pass2depth.vert \
    shaders/hybrid/pass2stencilBuffer.frag \
    shaders/hybrid/pass2stencilBuffer.vert \
    shaders/bufferviewdepth.frag \
    shaders/Light/gouraud.vert \
    shaders/Light/gouraud.frag \
    shaders/Light/flat.vert \
    shaders/Light/phong.vert \
    shaders/Light/phong.frag \
    shaders/Light/flat.frag \
    shaders/solid.frag \
    shaders/shadowmappcf.frag \
    shaders/hybrid/pass2ATI.frag \
    shaders/shadowmap.frag \
    shaders/shadowmap.vert \
    shaders/bufferviewtexture.frag \
    shaders/solid.vert \
    shaders/shadowcubemap.frag \
    shaders/shadowcubemap.vert \
    shaders/shadowcubemappcf.frag \
    shaders/rayintersection.geo \
    shaders/gbuffer.frag \
    shaders/ssao.frag \
    shaders/ssaoblurcolor.frag \
    shaders/shadowmap.geo \
    shaders/shadowcubemapmulti.frag \
    shaders/gbufferdd.frag \
    shaders/ssaodd.frag \
    shaders/material.frag

RESOURCES +=
