/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef DEMOCONTROLLER_H
#define DEMOCONTROLLER_H

#include <QObject>
#include <QPainter>

#include <QTime>

#include <variables.h>


/**
 * Kontroler pro rizeni behu automatickeho dema
 */
class DemoController : public QObject
{
    Q_OBJECT
public:
    explicit DemoController(QObject *parent = 0);

    /**
     * Vykresleni infomaci
     * @param painter
     */
    void drawDemoGui(QPainter *painter);

    /**
     * Aktualizace sceny podle casu
     */
    void update();

private:
    /* faze dema */
    enum PhaseEnum{
        init=-1,
        sm_1=0,
        sm_2,
        sm_3,
        sm_4,
        sm_5,
        sm_pcf,
        sm_multi,
        ssao,
        sv_1,
        sv_2,
        h_1,
        h_2,
        h_3,
        h_4,
        h_5,
        h_6,
        phaseCount,
        end,
        start,
    };

    /**
     * Prepocet pozice svetla
     */
    void setLight();

    PhaseEnum phase = init;

    QTime timer;

    Variables * var;

    int phaseTime=0;
    int phaseLength=0;

    int lightTime=0;

    bool loaded=false;
    QString title;

    bool cameraOrbit=false;
    int cameraStart=0;
signals:
    void setShader(Variables::Shader);
public slots:
    /**
     * Slot pro presun na dalsi fazi
     */
    void next();

    void prev();

    /**
     * Slot pro signalizaci ukonceneho nacitani
     */
    void loadingFinished();

};

#endif // DEMOCONTROLLER_H
