/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef GLVIEW_H
#define GLVIEW_H

#include <QGraphicsView>
#include <QMouseEvent>
#include <QKeyEvent>
#include <QGLWidget>

#include "baseshader.h"
#include "scenechooser.h"
#include "shaderchooser.h"

#include "demo/democontroller.h"

/**
 * Widget pro zobrazeni 3D sceny pomoci shader
 * umoznuje jednoduche prepinani mezi shadery
 */
class GLView : public QGraphicsView
{
    Q_OBJECT
public:
    explicit GLView(QWidget *parent = 0);


    /* eventy mysi */
    void resizeEvent(QResizeEvent *ev);
    void mouseMoveEvent(QMouseEvent *ev);
    void mouseReleaseEvent(QMouseEvent *);
    void mousePressEvent(QMouseEvent *ev);
    void wheelEvent(QWheelEvent *ev);

    /* event klavesnice*/
    void keyReleaseEvent(QKeyEvent *ev);

private:
    bool mousePressed;

    BaseShader* shader=NULL;

    Variables* var;

    ShaderChooser* shaderChooser=NULL;

    DemoController* demoController=NULL;

    QGLWidget* glw;

    bool mouseOverShaderChooser(QPoint p);

protected:
    void drawBackground(QPainter *painter, const QRectF &rect);
signals:

public slots:
    /**
     * Nastavi aktivni shader
     * @param s
     */
    void setShader(BaseShader *s);
    void setShader(Variables::Shader s);
    /**
     * Vytvori novy shader stejneho typu jako stavajici
     */
    void reloadShader();
};

#endif // GLVIEW_H
