#include "scenechooser.h"
#include "ui_scenechooser.h"

#include <QDebug>

#include "scenemanager.h"

SceneChooser::SceneChooser(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::SceneChooser)
{
    ui->setupUi(this);
    QPalette p;
    p.setColor(QPalette::Window,QColor(0,0,0,0));
    this->setPalette(p);
    p.setColor(QPalette::Window,QColor(255,255,255,255));
    ui->groupBox->setPalette(p);
    ui->groupBox->setAutoFillBackground(true);

    ui->groupBox_2->setPalette(p);
    ui->groupBox_2->setAutoFillBackground(true);

    proxy=NULL;
    var = Variables::i();

    ui->lowButton->setChecked(!var->highPoly);
    ui->highButton->setChecked(var->highPoly);





    bg.addButton(ui->rbAngel,Scenes::Angel);
    ui->rbAngel->setChecked(true);
    bg.addButton(ui->rbBox,Scenes::Cube);
    bg.addButton(ui->rbDragon,Scenes::Dragon);
    bg.addButton(ui->rbHut,Scenes::Hut);
    bg.addButton(ui->rbSphere,Scenes::Sphere);
    bg.addButton(ui->rbSponza,Scenes::Sponza);
    bg.addButton(ui->rbHut,Scenes::Hut);
    bg.addButton(ui->rbChess,Scenes::Chess);
    bg.addButton(ui->rbAeroworks,Scenes::Aeroworks);
    bg.addButton(ui->rbPole,Scenes::Pole);

    QAbstractButton* b = bg.button(SceneManager::i()->getActiveSceneIndex());
    if(b)b->setChecked(true);


    bg2.addButton(ui->rbEmpty,Scenes::Empty);
    bg2.addButton(ui->rbWalls,Scenes::Walls);
    ui->rbWalls->setChecked(true);
    bg2.addButton(ui->rbFloor,Scenes::Floor);

    b=bg2.button(SceneManager::i()->getActiveBackgroundIndex());
    if(b)b->setChecked(true);

    connect(&bg,SIGNAL(buttonClicked(int)),this,SLOT(select(int)));
    connect(&bg2,SIGNAL(buttonClicked(int)),this,SLOT(selectBg(int)));
}

SceneChooser::~SceneChooser()
{
    delete ui;
}

void SceneChooser::select(int id)
{
    if(id>=0){
        SceneManager::i()->setActiveScene(id+(var->highPoly?1:0));
    }
}

void SceneChooser::selectBg(int id)
{
    if(id>=0){
        SceneManager::i()->setActiveBackground(id);
    }
}

void SceneChooser::on_lowButton_toggled(bool checked){
    if(checked){
        var->highPoly=false;
        select(bg.checkedId());
    }
}
void SceneChooser::on_highButton_toggled(bool checked)
{
    if(checked){
        var->highPoly=true;
        select(bg.checkedId());
    }
}
