/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef SCENECHOOSER_H
#define SCENECHOOSER_H

#include <QWidget>
#include <QEvent>

#include <QGraphicsProxyWidget>

#include <QButtonGroup>

#include "variables.h"

namespace Ui {
class SceneChooser;
}

/**
 * Widget na prepinani scen
 */
class SceneChooser : public QWidget
{
    Q_OBJECT

public:
    explicit SceneChooser(QWidget *parent = 0);
    ~SceneChooser();

    void setProxy(QGraphicsProxyWidget*proxy){
        this->proxy=proxy;
    }


protected:
    /* zobrazi widget pouze pri najezdu mysi*/
    void enterEvent(QEvent *){
        if(proxy)proxy->setOpacity(1);
    }
    void leaveEvent(QEvent *){
        if(proxy)proxy->setOpacity(0.001);
    }

private slots:

    void on_lowButton_toggled(bool checked);
    void on_highButton_toggled(bool checked);

    void select(int id);
    void selectBg(int id);

private:
    Ui::SceneChooser *ui;
    QGraphicsProxyWidget *proxy;
    Variables* var;

    QButtonGroup bg,bg2;


};

#endif // SCENECHOOSER_H
