/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef LIGHT_H
#define LIGHT_H

#include <QVector3D>

/**
 * Struktura pro svetlo
 */
class Light
{
public:
    Light();
    Light(QVector3D position,
          QVector3D Ld=QVector3D(1,1,1),
          QVector3D La=QVector3D(0,0,0),
          QVector3D Ls=QVector3D(1,1,1),
          bool castShadow=true);

    QVector3D position;

    QVector3D La;
    QVector3D Ls;
    QVector3D Ld;

    bool castShadow=true;
};

#endif // LIGHT_H
