/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef MATERIAL_H
#define MATERIAL_H

#include "variables.h"

#include <QColor>

/**
 * Trida pro uchovani a nacitani materialu
 */
class Material
{
public:
    Material();
    /**
     * Material z barvy
     * @param c
     * @return
     */
    static Material* solidColorMaterial(QColor c);
    /**
     * Material z textury
     * @param file
     * @return
     */
    static Material* textureMaterial(QString file);
    /**
     * Vychozi material
     * @return
     */
    static Material* defaultMaterial();

    /**
     * Pomocna funkce pro ziskani textury ze souboru s obrazkem
     * @param file
     * @return
     */
    static GLuint textureFromFile(QString file);

    GLuint texture=0;
};

#endif // MATERIAL_H
