/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef MODEL_H
#define MODEL_H

#include <QVector>

typedef struct {
    float pos[3];
    float norm[3];
    float tex[2];
}Vertex;

/**
 * Trida modelu
 * seznam vertexu a elementu
 */

class Model
{
public:
    Model();
    QVector<Vertex> vertices;
    QVector<uint> elements;    
    QVector<Vertex> boundingBoxVertices;
    QVector<uint> boundingBoxElements;
    bool quads=false;
};

#endif // MODEL_H
