/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef MODELLOADER_H
#define MODELLOADER_H

#include "model.h"

#include <QString>
#include <QVector>
#include <QVector3D>
#include <QMap>

/**
 * Trida na nacitani modelu z .obj
 */
class ModelLoader
{
public:
    ModelLoader();

    /* seznam jiz nactenych modelu */
    static QMap<QString,Model*> models;

    /**
     * Nacte model ze souboru nebo vrati jiz nacteny
     * @param name jmeno souboru
     * @param scale meritko
     * @return
     */
    static Model* load(QString name, QVector3D scale = QVector3D(1,1,1));

    /* metody pro zjednoduseni nacitani */
    static Model* cube();
    static Model* quad();
    static Model* sphere();
    static Model* angelLowPoly();
};

#endif // MODELLOADER_H
