/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#include "scene.h"

Scene::Scene(QObject *parent) :
    QObject(parent)
{

    root = new Node();
}

Scene::~Scene(){
    unload();
}

void Scene::load(){
    qDebug() << "Scene::load()";
    if(!loaded){
        loaded=true;
        initializeOpenGLFunctions();
        root->load();
        root->fixParents();
    }
}

void Scene::unload(){
    if(loaded){
        loaded=false;
        root->unload();
    }
}

void Scene::draw(QOpenGLShaderProgram* shader){
    //qDebug() << "Scene::draw";
    shader->bind();

    root->drawByParent(shader,QMatrix4x4(),QMatrix4x4(),Material::defaultMaterial());
}

DrawList *Scene::createDrawList()
{
    DrawList* d= new DrawList;
    root->addToDrawList(d,QMatrix4x4(),QMatrix4x4(),Material::defaultMaterial());
    return d;
}

Scene *Scene::clone(){
    Scene * ret = new Scene;
    ret->root = this->root->clone();
    ret->loaded = loaded;
    return ret;
}
