/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef SCENE_H
#define SCENE_H

#include <QObject>
#include <QMatrix4x4>
#include <QOpenGLShaderProgram>

#include "variables.h"
#include "model.h"
#include "modelloader.h"

#include "node.h"
#include "drawlist.h"


/**
 * Trida graficke sceny
 * pouze odkaz na korenovy Node
 */
class Scene : public QObject, protected GLFun
{
    Q_OBJECT
public:
    explicit Scene(QObject *parent = 0);
    virtual ~Scene();

    /**
     * Nacteni sceny
     */
    void load();
    /**
     * smazani sceny
     */
    void unload();

    /**
     * Vykresleni sceny
     * @param aktivni shader program
     */
    virtual void draw(QOpenGLShaderProgram* shader);

    DrawList* createDrawList();

    /* koren grafu */
    Node* root;

    /* priznak nacteni sceny*/
    bool loaded = false;

    Scene* clone();
signals:

public slots:

};

#endif // SCENE_H
