/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#include "scenemanager.h"

SceneManager *SceneManager::instance=NULL;
SceneManager *SceneManager::i(){
    if(instance==NULL){
        instance=new SceneManager;
    }
    return instance;
}

SceneManager::SceneManager(){
    setActiveScene(Scenes::Angel);
    setActiveBackground(Scenes::Walls);

    lights.append(Light(QVector3D(30,30,0),QVector3D(1,1,1  )));
}

SceneManager::~SceneManager(){

}

Scene *SceneManager::get(){
    return i()->getActiveScene();
}

Scene *SceneManager::get(int n){
    return Scenes::getScene(n);
}

Scene *SceneManager::getWalls(){
    return Scenes::getScene(Scenes::Walls);
}

Scene *SceneManager::getLight(){
    Scene* s = Scenes::getScene(Scenes::Light);
    s->root->translation=QVector3D(Variables::i()->lightPos);
    return s;
}

Scene *SceneManager::getActiveScene(){
    return activeScene;
}

void SceneManager::setActiveScene(int n){
    qDebug()<<"selecting" << n;
    if(n>=0 && n<Scenes::SCENE_COUNT){
        activeSceneIndex = n;
        activeScene = Scenes::getScene(n);
        activeScene->load();
    }
}

void SceneManager::setActiveScene(Scene *n){
    activeScene = n;
    n->load();
}

int SceneManager::getActiveSceneIndex(){
    return activeSceneIndex;

}

int SceneManager::getActiveBackgroundIndex(){
    return activeBackgroundIndex;
}

Scene *SceneManager::getActiveBackground(){
    return activeBackground;
}

void SceneManager::setActiveBackground(int n)
{
    qDebug() << "setActiveBackground" << n;
    if(n>=0 && n<Scenes::SCENE_COUNT){
        activeBackgroundIndex = n;
        activeBackground = Scenes::getScene(n);
        activeBackground->load();
    }
}

void SceneManager::setActiveBackground(Scene *n)
{
    activeBackground = n;
    n->load();
}

Scene *SceneManager::getBg(){
    return i()->getActiveBackground();
}

