/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */


#ifndef GBUFFER_H
#define GBUFFER_H

#include "baseshader.h"

/**
 * Shader pro tvorbu G-Bufferu
 */
class GBuffer : public BaseShader
{
    Q_OBJECT
public:
    explicit GBuffer(QObject *parent = 0);

    enum{NMD,NMDD};
    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init(int type=NMD);
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

    void drawGBuffer(int type=NMD);
protected:
    QOpenGLShaderProgram programGBuffer;
    QOpenGLShaderProgram programGBufferDD;
    QOpenGLTimeMonitor timerGBuffer;

    GLuint frameBufferGBuffer;
    GLuint texNormal;
    //GLuint texPosition;
    GLuint texMaterial;
    GLuint texDepth;
    GLuint texDepth2;

    GLuint64 timeGBuffer;
};

#endif // GBUFFER_H
