/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef EXPERIMENTALSHADER_H
#define EXPERIMENTALSHADER_H
#include "baseshader.h"

/**
 * Hybridni shader kombinujici stinove mapy a stinova telesa
 */
class HybridShader : public BaseShader
{
public:
    HybridShader();

    enum Passes{
        PASS1_DRAW_SHADOWMAP=0,
        PASS2_DRAW_EDGES,
        PASS2_DRAW_STENCIL,
        PASS3_DRAW_SHADOW_VOLUMES,
        FINAL=256
    };
protected:
    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

private:
    QOpenGLShaderProgram programPass1;
    QOpenGLShaderProgram programPass1DrawBuffer;

    QOpenGLShaderProgram programPass2;
    QOpenGLShaderProgram programPass2Buffer;
    QOpenGLShaderProgram programPass2Depth;
    QOpenGLShaderProgram programPass2StencilBuffer;

    QOpenGLShaderProgram programShadowVolume;

    QOpenGLTimeMonitor time;

    // pass 1
    GLuint shadowTexture;
    GLuint frameBuffer;

    // pass 2
    GLuint frameBuffer2;
    GLuint texturePass2;
    GLuint texturePass2Light;
    GLuint texturePass2Edges;
    GLuint renderBufferDepth;

    GLuint fullScreenQuadVBO;
};

#endif // EXPERIMENTALSHADER_H
