/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef LIGHTSHADER_H
#define LIGHTSHADER_H

#include "baseshader.h"

#include <QOpenGLShaderProgram>

/**
 * Shader pro vykreslovani ruznych druhu osvetleni a stinovani
 */
class LightShader : public BaseShader
{
    Q_OBJECT
public:
    explicit LightShader(QObject *parent = 0);

    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);
protected:
    QOpenGLShaderProgram programFlat;
    QOpenGLShaderProgram programGouraud;
    QOpenGLShaderProgram programPhong;

        QOpenGLTimeMonitor time;
};

#endif // LIGHTSHADER_H
