/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#include "loadingshader.h"

#include <qthread.h>

LoadingShader::LoadingShader(QObject *parent) :
    BaseShader(parent)
{
}

void LoadingShader::init()
{
    threads.setMaxThreadCount(1);
    threads.start(new LoadThread("assets/angelHighPoly.obj"));
}

void LoadingShader::freeGL()
{

}

void LoadingShader::draw(QPainter *painter)
{
    glClearColor(0,0,0,0);
    glClear(GL_COLOR_BUFFER_BIT);

    painter->setPen(Qt::yellow);

    QFont font;
    font.setPixelSize(36);

    painter->setFont(font);
    painter->drawText(this->sceneRect().toRect(), Qt::AlignCenter, "Loading models...");

    QFont fontd;
     painter->setFont(fontd);

    if(threads.activeThreadCount()==0){
        emit finished();
    }

}


void LoadThread::run()
{
    ModelLoader::load("assets/angelHighPoly.obj");
}
