/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */


#ifndef LOADINGSHADER_H
#define LOADINGSHADER_H

#include "baseshader.h"

#include <QRunnable>
#include <QThreadPool>

/**
 * Shader pro nacitani modelu v extra vlaknu a vykresleni zpravy o nacitani
 */
class LoadingShader : public BaseShader
{
    Q_OBJECT
public:
    explicit LoadingShader(QObject *parent = 0);

    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

private:
    QThreadPool threads;
signals:
    void finished();
public slots:

};

/**
 * Pracovni vlakno
 */
class LoadThread: public QRunnable{
public:
    /**
     * @param file Nacitany model
     */
    LoadThread(QString file){
        this->file=file;
    }
    virtual void run();

private:
    QString file;
};

#endif // LOADINGSHADER_H
