/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef MATERIALSHADER_H
#define MATERIALSHADER_H

#include "baseshader.h"

/**
 * Shader pro vykreslovani materialu
 */
class MaterialShader : public BaseShader
{
    Q_OBJECT
public:
    explicit MaterialShader(QObject *parent = 0);

    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);
protected:
    GLuint texDiffuse;
    GLuint texNormal;
    GLuint texEmit;
    GLuint texSpecular;

    GLuint VBO;

    QMatrix4x4 m[6];
    QMatrix4x4 mNorm[6];
    QOpenGLShaderProgram program;
};

#endif // MATERIALSHADER_H
