/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */


#ifndef MOUSEPICKSHADER_H
#define MOUSEPICKSHADER_H

#include "lightshader.h"
#include "raycollision.h"

/**
 * Shader pro testovani RayCollision pouziteho u sachu
 * Zvyraznuje vybrany trojuhelnik a vykresluje paprsek z kamery do kliknuteho mista
 */
class MousePickShader : public LightShader
{
    Q_OBJECT
public:
    explicit MousePickShader(QObject *parent = 0);
    virtual ~MousePickShader();

protected:
    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

protected:
    GLuint VBO,VBO2,VBOline;
    QOpenGLShaderProgram programHighlight;

    RayCollision rayCollision;


};

#endif // MOUSEPICKSHADER_H
