/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */


#ifndef SHADOWCUBEMAPSHADER2_H
#define SHADOWCUBEMAPSHADER2_H

#include "baseshader.h"

/**
 * Shader pro stinove mapy vyuzivajici cubemap
 * Vyuziva geometry shader k nahrazeni nutnosti vykreslovat sestkrat
 */
class ShadowCubemapShader2 : public BaseShader
{
    Q_OBJECT
public:
    explicit ShadowCubemapShader2(QObject *parent = 0);
    virtual ~ShadowCubemapShader2();

protected:
    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

protected:
    QOpenGLShaderProgram program;
    QOpenGLShaderProgram programShadowmap;

    QOpenGLShaderProgram programPCF;
    QOpenGLTimeMonitor time;

    GLuint shadowCubemap;
    GLuint frameBuffer;

signals:

public slots:

};

#endif // SHADOWCUBEMAPSHADER2_H
