/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef SHADOWSMAPHADER_H
#define SHADOWSMAPHADER_H

#include "baseshader.h"

/**
 * Shader pro tvorbu stinu pomoci stinovych map
 */
class ShadowMapShader : public BaseShader
{
    Q_OBJECT
public:
    explicit ShadowMapShader(QObject *parent = 0);
    virtual ~ShadowMapShader();

protected:
    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

private:
    QOpenGLShaderProgram program;
    QOpenGLShaderProgram programDepth;
    QOpenGLShaderProgram programShadowmap;
    QOpenGLShaderProgram programPCF;
    QOpenGLShaderProgram programBuffer;

    QOpenGLTimeMonitor time;

    GLuint shadowTexture;
    GLuint frameBuffer;

    GLuint VBO;
signals:

public slots:

};

#endif // SHADOWSMAPHADER_H
