/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */


#ifndef SHADOWMULTICUBEMAPSHADER_H
#define SHADOWMULTICUBEMAPSHADER_H

#include "baseshader.h"
#include "gbuffer.h"

#include "light.h"

#define MAX_TEXTURES 32

class ShadowMultiCubemapShader : public GBuffer
{
    Q_OBJECT
public:
    explicit ShadowMultiCubemapShader(QObject *parent = 0);
    virtual ~ShadowMultiCubemapShader();
protected:
    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

    virtual void updateByTime(int ms);

    void setupLights();

protected:
    QOpenGLShaderProgram programBlendLight;
    QOpenGLShaderProgram programShadowmap;
    QOpenGLShaderProgram programBufferView;

    QOpenGLTimeMonitor timeShadowmap;

    GLuint shadowCubemap[MAX_TEXTURES];
    GLuint frameBufferShadowmap;

    GLuint frameBufferColor;
    GLuint colorTexture;
    GLuint renderBufferDepth;

    GLuint VBO;

    GLint maxTextures;

    QVector<Light> lights;

signals:

public slots:

};
#endif // SHADOWMULTICUBEMAPSHADER_H
