#ifndef SHADOWVOLUMESCISSORSHADER_H
#define SHADOWVOLUMESCISSORSHADER_H

#include "baseshader.h"

class ShadowVolumeScissorShader : public BaseShader
{
    Q_OBJECT
public:
    explicit ShadowVolumeScissorShader(QObject *parent = 0);

protected:
    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void free();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

private:
    QOpenGLShaderProgram program;
    QOpenGLShaderProgram programShadowVolume;
    QOpenGLShaderProgram programBuffer;

    QOpenGLShaderProgram programShadowmap;
    QOpenGLShaderProgram programShadowmapCreate;

    QOpenGLTimeMonitor time;

    GLuint shadowCubemap;
    GLuint indexCubemap;


    GLuint frameBuffer;
    GLuint SS;

signals:

public slots:

};

#endif // SHADOWVOLUMESCISSORSHADER_H
