/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef SHADOWVOLUMESHADER_H
#define SHADOWVOLUMESHADER_H

#include "baseshader.h"

/**
 * Shader pro tvorbu stinu pomoci stinovych teles
 */
class ShadowVolumeShader : public BaseShader
{
    Q_OBJECT
public:
    explicit ShadowVolumeShader(QObject *parent = 0);

protected:
    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);

private:
    QOpenGLShaderProgram program;
    QOpenGLShaderProgram programShadowVolume;
    QOpenGLShaderProgram programBuffer;

    QOpenGLTimeMonitor time;

signals:

public slots:

};

#endif // SHADOWVOLUMESHADER_H
