/**
 *
 * Diplomova prace
 * Stinove techniky na dnesnim hardware a jejich porovnani
 *
 * Michal Toth
 *
 * Fakulta informacnich technologii
 * Vysoke uceni technicke v Brne
 *
 * 2013/2014
 *
 */

#ifndef SSAOSHADER_H
#define SSAOSHADER_H

#include "gbuffer.h"

/**
 * Shader pro tvorbu Screen Space Ambient Occlusion,
 * potrebje GBuffer
 */
class SSAOShader : public GBuffer
{
    Q_OBJECT
public:
    explicit SSAOShader(QObject *parent = 0);

    /**
     * Inicializace OpenGL prostredku
     * @brief init
     */
    virtual void init();
    /**
     * Uvolneni OpenGL prostredku
     * @brief free
     */
    virtual void freeGL();
    /**
     * Vykresleni okna
     * @brief draw
     * @param painter Aktivni painter
     */
    virtual void draw(QPainter *painter);
protected:
    QOpenGLShaderProgram programSSAO;
    QOpenGLShaderProgram programSSAODD;
    QOpenGLShaderProgram programBlurColor;

    QOpenGLTimeMonitor timerSSAO;

    GLuint64 timeSSAO;

    GLuint texRandomHemisphere;

    GLuint VBO;

    GLuint frameBufferSSAO;
    GLuint texSSAO;
    GLuint renderBufferDepth;

};

#endif // SSAOSHADER_H
